3 # Copyright (c) 2005 Junio C Hamano
4 # Copyright (c) 2006 Yann Dirson - tuning for stgit
7 # For repeatability, reset the environment to known value.
12 export LANG LC_ALL PAGER TZ
16 unset COMMIT_AUTHOR_EMAIL
17 unset COMMIT_AUTHOR_NAME
18 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
20 GIT_AUTHOR_EMAIL=author@example.com
21 GIT_AUTHOR_NAME='A U Thor'
22 unset GIT_COMMITTER_DATE
23 GIT_COMMITTER_EMAIL=committer@example.com
24 GIT_COMMITTER_NAME='C O Mitter'
27 unset GIT_EXTERNAL_DIFF
29 unset GIT_OBJECT_DIRECTORY
30 unset SHA1_FILE_DIRECTORIES
31 unset SHA1_FILE_DIRECTORY
32 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
33 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
35 # Each test should start with something like this, after copyright notices:
37 # test_description='Description of this test...
38 # This test checks if command xyzzy does the right thing...
52 test "${test_description}" != "" ||
53 error "Test script did not set test_description."
58 -d|--d|--de|--deb|--debu|--debug)
60 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
62 -h|--h|--he|--hel|--help)
63 echo "$test_description"
65 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
73 if test "$verbose" = "t"
77 exec 4>/dev/null 3>/dev/null
83 trap 'echo >&5 "FATAL: Unexpected exit with code $?"; exit 1' exit
86 # You are not expected to call test_ok_ and test_failure_ directly, use
87 # the text_expect_* functions instead.
90 test_count=$(expr "$test_count" + 1)
91 say " ok $test_count: $@"
95 test_count=$(expr "$test_count" + 1)
96 test_failure=$(expr "$test_failure" + 1);
97 say "FAIL $test_count: $1"
99 echo "$@" | sed -e 's/^/ /'
100 test "$immediate" = "" || { trap - exit; exit 1; }
105 test "$debug" = "" || eval "$1"
114 test_expect_failure () {
116 error "bug in the test script: not 2 parameters to test-expect-failure"
117 say >&3 "expecting failure: $2"
119 if [ "$?" = 0 -a "$eval_ret" != 0 ]
127 test_expect_success () {
129 error "bug in the test script: not 2 parameters to test-expect-success"
130 say >&3 "expecting success: $2"
132 if [ "$?" = 0 -a "$eval_ret" = 0 ]
140 test_expect_code () {
142 error "bug in the test script: not 3 parameters to test-expect-code"
143 say >&3 "expecting exit code $1: $3"
145 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
153 # Most tests can use the created repository, but some amy need to create more.
154 # Usage: test_create_repo <directory>
155 test_create_repo () {
157 error "bug in the test script: not 1 parameter to test-create-repo"
161 cd "$repo" || error "Cannot setup test environment"
162 git-init-db 2>/dev/null ||
163 error "cannot run git-init-db -- have you installed git-core?"
164 mv .git/hooks .git/hooks-disabled
166 git-commit-tree `git-write-tree` >.git/refs/heads/master 2>/dev/null ||
167 error "cannot run git-commit -- is your git-core funtionning?"
173 case "$test_failure" in
176 # cd .. && rm -fr trash
177 # but that means we forbid any tests that use their own
178 # subdirectory from calling test_done without coming back
179 # to where they started from.
180 # The Makefile provided will clean this test area so
181 # we will leave things as they are.
183 say "passed all $test_count test(s)"
187 say "failed $test_failure among $test_count test(s)"
193 # Test the binaries we have just built. The tests are kept in
194 # t/ subdirectory and are run in trash subdirectory.
203 test_create_repo $test